//+------------------------------------------------------------------+
//|                                   ClusterDelta_Ask_Bid indicator |
//|                                           Copyright  ظ 2012 |
//|                                   mode 0   Noumen     |
//|                                    modified for ClusterX by richi|
//|                                           http://clusterdelta.com|
//+------------------------------------------------------------------+

//---- indicator settings
#property copyright " ظ 2012"
#property link      "http://clusterdelta.com"
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  SlateGray
#property  indicator_width1  2

#property  indicator_color2  Green
#property  indicator_width2  2

#property  indicator_color3  Red
#property  indicator_width3  2

#property  indicator_minimum 0
//---- indicator parameters
extern int mode=0;
extern string Instrument="AUTO";

//---- indicator buffers
double     Buffer1[];
double     Buffer2[];
double     Buffer3[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);   
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,Buffer1);
   SetIndexBuffer(1,Buffer2);
   SetIndexBuffer(2,Buffer3);
   //---- name for DataWindow and indicator subwindow label
   IndicatorShortName ("VolumeX");
  }
   return(0);   
/*+------------------------------------------------------------------+
  |                                               |
  +------------------------------------------------------------------+*/
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;                   //   
   limit=Bars-counted_bars;


   int bid, ask, volume, delta;
   for(int i=0; i<limit; i++)
     {
     volume=iCustom(Symbol(),0,"ClusterX_Volume",Instrument,0,i);
     delta=iCustom(NULL,0,"ClusterX_Delta",Instrument,0,i);
     bid=(volume-delta)/2;                               // 
     ask=delta+bid;                                      // 
     
     if(mode==0)     //mode=0:    
     {   
      if(delta<0 && Open[i]<=Close[i])
      {
       Buffer1[i]=0;
       Buffer2[i]=0; 
       Buffer3[i]=volume;
      }   
        else
        { 
         if(delta>0 && Open[i]>=Close[i])
           {
            Buffer1[i]=0;
            Buffer2[i]=volume; 
            Buffer3[i]=0;
           }         
      
              else 
               {
                Buffer1[i]=volume;
                Buffer2[i]=0;
                Buffer3[i]=0; 
               }
         }
     }
     else
     {
     if (mode==1)     //mode=1:   .
     {
       Buffer1[i]=ask+bid;
       Buffer2[i]=bid; 
       Buffer3[i]=0;
     } 
     else
     {  
     if (mode==2)      //mode=2:         .
     {
       if (Open[i]>=Close[i])
       {
        Buffer1[i]=0;
        Buffer2[i]=volume; 
        Buffer3[i]=0;
       }
        else
       {
        Buffer1[i]=volume;
        Buffer2[i]=0; 
        Buffer3[i]=0;
       }    
     }
     else     //mode=3:       ,       . 
     {    
       if (iCustom(Symbol(),0,"ClusterX_Volume",Instrument,0,i)>=iCustom(Symbol(),0,"ClusterX_Volume",Instrument,0,i+1))
       {
        Buffer1[i]=0;
        Buffer2[i]=volume; 
        Buffer3[i]=0;
       }
       else
       {
        Buffer1[i]=0;
        Buffer2[i]=0; 
        Buffer3[i]=volume;
       } 
     }   
     }
     }
     }     
     
/**/
   return(0);
  }
/*+------------------------------------------------------------------+*/